library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ClockManagement is
    Port ( SystemClk : in std_logic;
           SystemReset : in std_logic;
           ClkSPI : buffer std_logic--;
           --ResetSPI : out std_logic
			 );
end ClockManagement;

architecture Behavioral of ClockManagement is

	signal ClockDiv : integer range 4999 downto 0;	 -- 5 kHz aus 50 MHz
	signal ClockEnable : std_logic;
	
begin

	Clock_Div: process (SystemClk, SystemReset)
	begin
		if (SystemReset = '1') then
			ClockDiv <= 0;
			ClockEnable <= '0';
		elsif (rising_edge(SystemClk)) then
			if (ClockDiv < 4999) then
				ClockDiv <= ClockDiv + 1;
				ClockEnable <= '0';
			else
				ClockDiv <= 0;
				ClockEnable <= '1';
			end if;
		end if;
	end process Clock_Div;


	SPI_Clock: process (ClockEnable)
	begin
		if (ClockEnable = '1') then
			ClkSPI <= not(ClkSPI);
		end if;
	end process SPI_Clock;

end Behavioral;