library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Main is
    Port ( SystemClk : in std_logic;
           SystemReset : in std_logic;
           MISO : in std_logic;
			  BTN0 : in std_logic;
			  SPIClock : buffer std_logic;
           MOSI : out std_logic;
			  StatusLED : out std_logic;
			  EnableSPI : inout std_logic);			-- ###################### nur in ??????
end Main;

architecture Behavioral of Main is

	signal SendByte : std_logic_vector(7 downto 0) := "10101010";--"00000000";
	signal ClockDivider : std_logic_vector(3 downto 0) := "0000";
	signal ResetSPI : std_logic;


	component ClockManagement is
    port ( SystemClk : in std_logic;
           SystemReset : in std_logic;
           ClkSPI : buffer std_logic--;
           --ResetSPI : out std_logic
			  );
	end component ClockManagement;

	component ShiftRegisterOut is
    Port ( SystemClk : 		in 	std_logic;
           --SystemReset : 	in 	std_logic;
           ClkSPI : 			in 	std_logic;
           --ResetSPI : 		in 	std_logic;
			  SendData : 		in 	std_logic_vector(7 downto 0);
           MOSI : 			out 	std_logic--;
			  --Status : 			out 	std_logic;
			  --OutputEnable : 	inout std_logic
			  );
	end component ShiftRegisterOut;


begin
	
	SPIClockGen : ClockManagement port map (
												SystemClk 		=> SystemClk,
												SystemReset 	=> SystemReset,								
												ClkSPI 			=> SPIClock--,
												--ResetSPI 		=> ResetSPI
												);

	SPISendByte : ShiftRegisterOut port map (
    											SystemClk 		=> SystemClk,
           									--SystemReset 	=> SystemReset,
           									ClkSPI 			=> SPIClock,
           									--ResetSPI 		=> SPIClock,
			  									SendData 		=> SendByte,
          									MOSI 				=> MOSI--,
			  									--Status			=> StatusLED,
			  									--OutputEnable 	=> EnableSPI 
												);
end Behavioral;
