library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ShiftRegisterOut is
    Port ( SystemClk : 		in 	std_logic;
           SystemReset : 	in 	std_logic;
           ClkSPI : 			in 	std_logic;
           ResetSPI : 		in 	std_logic;
			  SendData : 		in 	std_logic_vector(7 downto 0);
           MOSI : 			out 	std_logic--;
			  --Status : 			out 	std_logic;
			  --OutputEnable : 	inout std_logic
			  );
end ShiftRegisterOut;

architecture Behavioral of ShiftRegisterOut is

	signal CountSentBits : integer range 7 downto 0 := 0;

begin

	OutputShiftReg: process (SystemClk, ClkSPI, SendData)--, SystemReset)
	begin
		if (ClkSPI = '0') then
			if (CountSentBits < 8) then
				MOSI <= SendData(CountSentBits);
			end if;
		end if;
  
		if (ClkSPI = '1') then
			CountSentBits <= CountSentBits + 1;
		end if;

	end process OutputShiftReg;	

end Behavioral;
